package com.fp.persistence.parmas.soli;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.sql.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMDOCUMENTOHABILITANTE*/
@Entity(name="TarmDocumentoHabilitante")
@Table(name="TARMDOCUMENTOHABILITANTE")
public class TarmDocumentoHabilitante extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmDocumentoHabilitante
*/
@Id
@Column(name="CDOCUMENTO" ,nullable=false, updatable=false)
private Long pk;
@Column(name="PERSONCODE", nullable=true)

/**
* Codigo de persona
*/
private Integer personcode;

@Column(name="NUMERODOCUMENTO", nullable=true)

/**
* Numero de documento habilitante
*/
private String numerodocumento;

@Column(name="FECHAEMISION", nullable=true)

/**
* Fecha en la que se emitio el documento
*/
private Date fechaemision;

@Column(name="FECHAEXPIRACION", nullable=true)

/**
* Fecha de expiracion del documento
*/
private Date fechaexpiracion;

@Column(name="CSOLICITUD", nullable=true)

/**
* null
*/
private String csolicitud;

@Column(name="XPATH", nullable=true)

/**
* Ruta en Alfresco donde se almacena el documento Habilitante.
*/
private String xpath;

@Column(name="CARMA", nullable=true)

/**
* null
*/
private String carma;

@Column(name="ESTADO", nullable=true)

/**
* null
*/
private String estado;

@Column(name="ESTADOCODE", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de estado de documento habilitante
*/
private String estadocode;

@Column(name="CODIGOARMA", nullable=true)

/**
* Codigo del arma identificador del arma
*/
private String codigoarma;

@Column(name="CTRAMITE", nullable=true)

/**
* null
*/
private Long ctramite;



@Column(name="CCENTROCONTROL", nullable=true)

/**
* CENTRO DE CONTROL
*/
private String centrocontrol;

@Column(name="CUENTAREIMPRESION", nullable=true)

/**
* null
*/
private Integer cuentareimpresion;


@Column(name="FECHACAMBIOEXPIRACION", nullable=true)

/**
* Fecha de expiracion del documento
*/
private Date fechacambioexpiracion;
@Column(name="OBSERVACION", nullable=true)

/**
* CENTRO DE CONTROL
*/
private String observacion;

@Column(name="PATHSUSPENCION", nullable=true)

/**
* Ruta en Alfresco donde se almacena el documento Habilitante.
*/
private String pathSuspencion;

/**Contructor por defecto*/
public TarmDocumentoHabilitante(){
}
/**Contructor de TarmDocumentoHabilitante
@param pPk Clave Primaria del entity
*/
public TarmDocumentoHabilitante(Long pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmDocumentoHabilitante
*/
public static TarmDocumentoHabilitante find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmDocumentoHabilitante obj = pEntityManager.find(TarmDocumentoHabilitante.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmDocumentoHabilitante
@return El objeto que referencia a la Clave primaria de TarmDocumentoHabilitante
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmDocumentoHabilitante
@param pPk El objeto que referencia a la nueva Clave primaria de TarmDocumentoHabilitante
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de numerodocumento
@return valor de numerodocumento*/
public String getNumerodocumento(){
  return numerodocumento;
}
/**Fija el valor de numerodocumento
@param pNumerodocumento nuevo Valor de numerodocumento*/
public void setNumerodocumento(String pNumerodocumento){
  numerodocumento=pNumerodocumento;
}

/**Obtiene el valor de fechaemision
@return valor de fechaemision*/
public Date getFechaemision(){
  return fechaemision;
}
/**Fija el valor de fechaemision
@param pFechaemision nuevo Valor de fechaemision*/
public void setFechaemision(Date pFechaemision){
  fechaemision=pFechaemision;
}

/**Obtiene el valor de fechaexpiracion
@return valor de fechaexpiracion*/
public Date getFechaexpiracion(){
  return fechaexpiracion;
}
/**Fija el valor de fechaexpiracion
@param pFechaexpiracion nuevo Valor de fechaexpiracion*/
public void setFechaexpiracion(Date pFechaexpiracion){
  fechaexpiracion=pFechaexpiracion;
}

/**Obtiene el valor de csolicitud
@return valor de csolicitud*/
public String getCsolicitud(){
  return csolicitud;
}
/**Fija el valor de csolicitud
@param pCsolicitud nuevo Valor de csolicitud*/
public void setCsolicitud(String pCsolicitud){
  csolicitud=pCsolicitud;
}

/**Obtiene el valor de xpath
@return valor de xpath*/
public String getXpath(){
  return xpath;
}
/**Fija el valor de xpath
@param pXpath nuevo Valor de xpath*/
public void setXpath(String pXpath){
  xpath=pXpath;
}

/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

/**Obtiene el valor de estado
@return valor de estado*/
public String getEstado(){
  return estado;
}
/**Fija el valor de estado
@param pEstado nuevo Valor de estado*/
public void setEstado(String pEstado){
  estado=pEstado;
}

/**Obtiene el valor de estadocode
@return valor de estadocode*/
public String getEstadocode(){
  return estadocode;
}
/**Fija el valor de estadocode
@param pEstadocode nuevo Valor de estadocode*/
public void setEstadocode(String pEstadocode){
  estadocode=pEstadocode;
}

/**Obtiene el valor de codigoarma
@return valor de codigoarma*/
public String getCodigoarma(){
  return codigoarma;
}
/**Fija el valor de codigoarma
@param pCodigoarma nuevo Valor de codigoarma*/
public void setCodigoarma(String pCodigoarma){
  codigoarma=pCodigoarma;
}

public String getCentrocontrol() {
	return centrocontrol;
}
public void setCentrocontrol(String centrocontrol) {
	this.centrocontrol = centrocontrol;
}
/**Obtiene el valor de ctramite
@return valor de ctramite*/
public Long getCtramite(){
  return ctramite;
}
/**Fija el valor de ctramite
@param pCtramite nuevo Valor de ctramite*/
public void setCtramite(Long pCtramite){
  ctramite=pCtramite;
}

/**Obtiene el valor de cuentareimpresion
@return valor de cuentareimpresion*/
public Integer getCuentareimpresion(){
  return cuentareimpresion;
}
/**Fija el valor de cuentareimpresion
@param pCuentareimpresion nuevo Valor de cuentareimpresion*/
public void setCuentareimpresion(Integer pCuentareimpresion){
  cuentareimpresion=pCuentareimpresion;
}

public Date getFechacambioexpiracion() {
	return fechacambioexpiracion;
}
public void setFechacambioexpiracion(Date fechacambioexpiracion) {
	this.fechacambioexpiracion = fechacambioexpiracion;
}
public String getObservacion() {
	return observacion;
}
public void setObservacion(String observacion) {
	this.observacion = observacion;
}
public String getPathSuspencion() {
	return pathSuspencion;
}
public void setPathSuspencion(String pathSuspencion) {
	this.pathSuspencion = pathSuspencion;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmDocumentoHabilitante))return false;
    TarmDocumentoHabilitante that = (TarmDocumentoHabilitante) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmDocumentoHabilitante
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmDocumentoHabilitante
*/
public Object createInstance(){
 TarmDocumentoHabilitante instance=new TarmDocumentoHabilitante();	
 return instance;
}
/**Clona la entidad TarmDocumentoHabilitante
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmDocumentoHabilitante p=(TarmDocumentoHabilitante)this.clone();
  return p;
}

}
